<?php

namespace EventPortal\Tests\Unit\Approval\Models;

use EventPortal\Domain\Approval\Models\ApprovalData as ApprovalModel;
use EventPortal\Tests\TestCase;
use Illuminate\Foundation\Testing\RefreshDatabase;

class ApprovalDataTest extends TestCase
{
    use RefreshDatabase;

    /** @test */
    public function approval_data_is_audited_when_updated(): void
    {
        config(['audit.console' => true]); // This needs to be before create, or no update audit is created

        $approvalData = factory(ApprovalModel::class)->create(['value' => 'before change']);

        $approvalData->update(['value' => 'after change']);

        $this->assertCount(2, $approvalData->fresh()->audits); // Created and updated

        $updatedAudit = $approvalData->fresh()->audits->last();

        $this->assertArraySubset(['value' => 'before change'], $updatedAudit->old_values);

        $this->assertArraySubset(['value' => 'after change'], $updatedAudit->new_values);
    }
}
