<?php

namespace EventPortal\Tests\Unit\Email\Handlers;

use EventPortal\Domain\Event\Handlers\CreateEmails;
use EventPortal\Domain\Event\Models\Event;
use EventPortal\Domain\Form\Payload;
use EventPortal\Enums\EmailType;
use EventPortal\Tests\TestCase;
use Illuminate\Foundation\Testing\RefreshDatabase;
use Illuminate\Pipeline\Pipeline;

class CreateEmailsTest extends TestCase
{
    use RefreshDatabase;

    /** @test **/
    public function can_create_emails()
    {
        $event = factory(Event::class)->create();

        $payload = Payload::make()->withModel($event);

        app(Pipeline::class)
            ->send($payload)
            ->through([new CreateEmails])
            ->thenReturn();

        foreach (EmailType::getIndices() as $emailType) {
            $this->assertDatabaseHas('event_emails', [
                'event_id' => $event->id,
                'type' => $emailType,
            ]);
        }
    }
}
